<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@ page import="org.wso2.carbon.registry.core.RegistryConstants" %>
<%@ page import="org.wso2.carbon.governance.services.ui.clients.AddServicesServiceClient" %>
<%@ page import="org.wso2.carbon.governance.services.ui.utils.AddServicesUtil" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="javax.xml.stream.XMLStreamReader" %>
<%@ page import="javax.xml.stream.XMLInputFactory" %>
<%@ page import="java.io.StringReader" %>
<%@ page import="org.apache.axiom.om.impl.builder.StAXOMBuilder" %>
<%@ page import="org.apache.axiom.om.OMElement" %>
<%@ page import="org.wso2.carbon.governance.services.ui.utils.AddServiceUIGenerator" %>
<%@ page import="org.wso2.carbon.governance.services.ui.utils.UIGeneratorConstants" %>
<%@ page import="javax.xml.namespace.QName" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>

<script type="text/javascript" src="../registry_common/js/registry_validation.js"></script>
<script type="text/javascript" src="../registry_common/js/registry_common.js"></script>
<script type="text/javascript" src="../ajax/js/prototype.js"></script>
<fmt:bundle basename="org.wso2.carbon.governance.services.ui.i18n.Resources">
<carbon:jsi18n
        resourceBundle="org.wso2.carbon.governance.services.ui.i18n.JSResources"
        request="<%=request%>" namespace="org.wso2.carbon.governance.services.ui"/>
<script type="text/javascript" src="../services/js/services.js"></script>
<%
    if(!CarbonUIUtil.isUserAuthorized(request, "/permission/admin/manage/resources/govern/metadata/add")){
        return;
    }
    String error = "Wrong configuration in " + RegistryConstants.GOVERNANCE_SERVICES_CONFIG_PATH;
    AddServicesServiceClient client = new AddServicesServiceClient(config,session);

    String path = request.getParameter("path");
    if (path.startsWith(RegistryConstants.GOVERNANCE_REGISTRY_BASE_PATH)) {
        path = path.substring(RegistryConstants.GOVERNANCE_REGISTRY_BASE_PATH.length());
    }
    boolean isVersionedPage = false;
    String disabledAttr = "";
    String saveButtonClass = "button registryWriteOperation";
    if (path.contains(";version")) {
        isVersionedPage = true;
        disabledAttr = " disabled=\"1\"";
        saveButtonClass = "button registryNonWriteOperation";
    }

    String content = client.editService(path);
    OMElement data = AddServicesUtil.loadaddedservicecontent(content);
    AddServiceUIGenerator gen = new AddServiceUIGenerator();
    OMElement uiconfig = gen.getUIconfiguration(client.getServiceConfiguration(),request,config,session);
    request.setAttribute("content",data);
    Iterator widgets = uiconfig.getChildrenWithName(new QName(null, UIGeneratorConstants.WIDGET_ELEMENT));
    StringBuffer table = new StringBuffer();
    while(widgets.hasNext()){
        OMElement widget = (OMElement)widgets.next();
        table.append(gen.printwidgetwithvalues(widget, data, true));
    }
    String[] mandatory = gen.getmandatoryidlist(uiconfig);
    String[] name = gen.getmandatorynamelist(uiconfig);
    String servicename = AddServicesUtil.getNamefromcontent(data);
    String servicenamespace = AddServicesUtil.getNamespacefromcontent(data);
    String[] addname = gen.getunboundednamelist(uiconfig);
    String[] addwidget = gen.getunboundedwidgetlist(uiconfig);
    String[][] selectvaluelist = gen.getunboundedvalues(uiconfig);
%>

<br/>
<script type="text/javascript">
    function addEditService(){
        sessionAwareFunction(function() {
            getServiceName();
            var reason = "";
        <%for(int i=0;i<mandatory.length;i++){%>
            var <%=mandatory[i]%>=document.getElementById('<%=mandatory[i]%>');
            reason += validateEmpty(<%=mandatory[i]%>,"<%=name[i]%>");
        <%}%>
            var CustomUIForm=document.getElementById('CustomUIForm');
            var waitMessage = document.getElementById('waitMessage');
            var buttonRow = document.getElementById('buttonRow');
            var serviceName = document.getElementById('id_Overview_Name');
            var namespaceValue = document.getElementById('id_Overview_Namespace');
            reason += validateIllegal(serviceName);
            reason += validateIllegal(namespaceValue);
            if(reason!=""){
                CARBON.showWarningDialog(reason);
            }else{
                buttonRow.style.display = "none";
                waitMessage.style.display = "";
                CustomUIForm.submit();
            }
        }, org_wso2_carbon_governance_services_ui_jsi18n["session.timed.out"]);
    }
    function getServiceName(){
        var serviceLoader= document.getElementById('serviceLoader');
        serviceLoader.innerHTML='<img src="images/ajax-loader.gif" align="left" hspace="20"/><fmt:message key="please.wait.saving.details.for"/> '+document.getElementById('id_Overview_Name').value+'...';
    }

    <%
       if(addname != null && addwidget != null && selectvaluelist != null){
       for(int i=0;i<addname.length;i++){%>
        <%=addname[i]%>Count = 0;
        jQuery(document).ready(function() {
            var countTracker = document.getElementById("<%=addname[i]%>CountTaker");
            if (countTracker != null && countTracker.value) {
                <%=addname[i]%>Count = parseInt(countTracker.value);
            }
        });

        function add<%=addname[i]%>_<%=addwidget[i]%>(){
        <%String[] valuelist = selectvaluelist[i];%>
            var epOptions = '<%for(int j=0;j<valuelist.length;j++){%><option value="<%=valuelist[j]%>"><%=valuelist[j]%></option><%}%>';
            var endpointMgt = document.getElementById('<%=addname[i]%>Mgt');
            endpointMgt.parentNode.style.display = "";
            if(<%=addname[i]%>Count >0){
                for(var i=1;i<=<%=addname[i]%>Count;i++){
                    var endpoint = document.getElementById(i);
                    if(endpoint == null || endpoint.value == ""){
                        return;
                    }
                }
            }
            <%=addname[i]%>Count++;
            var epCountTaker = document.getElementById('<%=addname[i]%>CountTaker');
            epCountTaker.value = <%=addname[i]%>Count;
            var theTr = document.createElement("TR");
            var theTd1 = document.createElement("TD");
            var theTd2 = document.createElement("TD");
            var td1Inner = '<select name="<%=(addwidget[i].replaceAll(" ","_") + "_" + addname[i].replaceAll(" ","-"))%>'+<%=addname[i]%>Count+'">' + epOptions + '</select>';
            var td2Inner = '<input id="'+<%=addname[i]%>Count+'" type="text" name="<%=addwidget[i].replaceAll(" ","-") + UIGeneratorConstants.TEXT_FIELD + "_" + addname[i].replaceAll(" ","-")%>'+<%=addname[i]%>Count+'" style="width:400px"/>';

            theTd1.innerHTML = td1Inner;
            theTd2.innerHTML = td2Inner;

            theTr.appendChild(theTd1);
            theTr.appendChild(theTd2);

            endpointMgt.appendChild(theTr);


        }
<%      }

   }%>

</script>

<div id="middle">


    <div id="workArea">

        <div id="activityReason" style="display: none;"></div>
        <form id="CustomUIForm" action="../services/add_service_ajaxprocessor.jsp" method="post">
            <input type="hidden" name="operation" value="Edit">
            <input type="hidden" name="currentname" value="<%=servicename%>">
            <input type="hidden" name="currentnamespace" value="<%=servicenamespace%>">
            <table class="styledLeft">
                <tr><td>
                    <%=table.toString()%>
                </td></tr>
                <% if(client.canChange(path)){%>
                <tr id="buttonRow">
                    <td colspan="3" class="buttonRow">
                        <input class="<%=saveButtonClass%>" type="button" <%=disabledAttr%>
                               value="<fmt:message key="save.service"/>" onclick="addEditService()"/>
                    </td>
                </tr>
                <tr id="waitMessage" style="display:none">
                    <td colspan="3">
                        <div style="font-size:13px !important;margin-top:10px;margin-bottom:10px;" id="serviceLoader">
                        </div>
                    </td>
                </tr>
            <%}%>
            </table>
        </form>
        <br/>

        <div id="AddService">
        </div>
    </div>
</div>
</fmt:bundle>
